=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -DQT_NO_DEBUG_OUTPUT

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCharm_VERSION=$(DEB_VERSION_UPSTREAM)

override_dh_auto_test:
	xvfb-run dh_auto_test
