## charmtimetracker 1.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
     SET( CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE )
 ENDIF()
 
-IF( APPLE AND CMAKE_INSTALL_PREFIX MATCHES "/usr/local" )
+IF( APPLE AND CMAKE_INSTALL_PREFIX STREQUAL "/usr/local" )
     SET( CMAKE_INSTALL_PREFIX "/Applications" )
 ENDIF()
 
@@ -37,9 +37,12 @@
 CMAKE_MINIMUM_REQUIRED( VERSION 2.6.0 )
 SET( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMake" )
 
-if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
-  set(CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
-endif()
+IF(CMAKE_COMPILER_IS_GNUCXX OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
+    SET(CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
+ENDIF()
+IF(MSVC)
+    SET(CMAKE_CXX_FLAGS "-D_USING_V110_SDK71_=1 ${CMAKE_CXX_FLAGS}")
+ENDIF()
 
 SET( CMAKE_AUTOMOC ON )
 
@@ -49,6 +52,8 @@
 IF( NOT CHARM_FORCE_QT4 )
     find_package( Qt5Core QUIET )
 ENDIF()
+
+set(QTKEYCHAIN_SYSTEM OFF)
 
 IF(Qt5Core_FOUND)
     find_package(Qt5Widgets REQUIRED)
@@ -56,6 +61,10 @@
     find_package(Qt5Network REQUIRED)
     find_package(Qt5Sql REQUIRED)
     find_package(Qt5Test REQUIRED)
+    find_package(Qt5Script REQUIRED)
+    if(WIN32)
+        find_package(Qt5WinExtras REQUIRED)
+    endif()
 
     find_package(Qt5PrintSupport)
     IF(Qt5PrintSupport_FOUND)
@@ -63,10 +72,16 @@
         set(QTPRINT_LIBRARIES ${Qt5PrintSupport_LIBRARIES})
     ENDIF()
 
+    find_package(Qt5Keychain QUIET)
+
+    IF(Qt5Keychain_FOUND)
+	set(QTKEYCHAIN_SYSTEM ON)
+    ENDIF()
+
     SET(CHARM_MAC_HIGHRES_SUPPORT_ENABLED ON)
 
     IF(WIN32)
-        SET(QT_PLATFORM_SPECIFIC_LIBRARIES Qt5::WinMain)
+        SET(QT_PLATFORM_SPECIFIC_LIBRARIES Qt5::WinMain Qt5::WinExtras)
     ELSE()
         SET(QT_PLATFORM_SPECIFIC_LIBRARIES)
     ENDIF()
@@ -108,29 +123,30 @@
     set(QT_QTTEST_LIBRARY ${Qt5Test_LIBRARIES})
 
     set(QT_LIBRARIES
-        ${Qt5Core_LIBRARIES}
-        ${Qt5Widgets_LIBRARIES}
-        ${Qt5Xml_LIBRARIES}
-        ${Qt5Network_LIBRARIES}
-        ${Qt5Sql_LIBRARIES}
-        ${QTPRINT_LIBRARIES}
-        ${QTDBUS_LIBRARIES}
+        Qt5::Core
+        Qt5::Widgets
+        Qt5::Xml
+        Qt5::Network
+        Qt5::Script
+        Qt5::Sql
+        Qt5::PrintSupport
+        ${QTKEYCHAIN_LIBRARIES}
         ${QT_PLATFORM_SPECIFIC_LIBRARIES}
     )
-
-    include_directories(
-        ${Qt5Core_INCLUDE_DIRS}
-        ${Qt5Widgets_INCLUDE_DIRS}
-        ${Qt5Xml_INCLUDE_DIRS}
-        ${Qt5Network_INCLUDE_DIRS}
-        ${Qt5Sql_INCLUDE_DIRS}
-    )
-
-    SET( CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${CMAKE_CXX_FLAGS}" )
+    if (TARGET Qt5::DBus)
+        list(APPEND QT_LIBRARIES Qt5::DBus)
+    endif()
 ELSE()
     # No Qt5 found, try Qt4
-    find_package(Qt4 COMPONENTS QtMain QtCore QtGui QtSql QtXml QtNetwork REQUIRED)
+    find_package(Qt4 COMPONENTS QtMain QtCore QtGui QtSql QtXml QtNetwork QtScript REQUIRED)
     INCLUDE( UseQt4 )
+
+    find_package(QtKeychain QUIET)
+    LIST(APPEND QT_LIBRARIES ${QTKEYCHAIN_LIBRARIES})
+
+    IF(QtKeychain_FOUND)
+        set(QTKEYCHAIN_SYSTEM ON)
+    ENDIF()
 
     SET(CHARM_MAC_HIGHRES_SUPPORT_ENABLED OFF)
 
@@ -152,7 +168,7 @@
         endmacro()
     ENDIF()
 
-    include_directories(${QT_INCLUDES})
+    include_directories(${QT_INCLUDES} ${QTKEYCHAIN_INCLUDE_DIRS})
     #set(QTCORE_LIBRARIES ${QT_QTCORE_LIBRARY})
 
     macro(qt_wrap_cpp)
@@ -189,28 +205,34 @@
 
 IF( CMAKE_COMPILER_IS_GNUCXX )
     # Add additional GCC options.
-    ADD_DEFINITIONS(
-        -Wall -Wundef -Wcast-align -Wchar-subscripts -Wpointer-arith
-        -Wwrite-strings -Wpacked -Wformat-security
-        -Wmissing-format-attribute -Wold-style-cast
-    )
-    ADD_DEFINITIONS( -fvisibility=hidden )
+    SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wundef -Wcast-align -Wchar-subscripts -Wpointer-arith")
+    SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wwrite-strings -Wpacked -Wformat-security")
+    SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wmissing-format-attribute -Wold-style-cast")
+    IF(NOT WIN32)
+        SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden ")
+    ENDIF()
 ELSEIF( CMAKE_CXX_COMPILER MATCHES "clang" )
-    ADD_DEFINITIONS( -Wall -Wextra -Wno-unused-parameter )
-    ADD_DEFINITIONS( -fvisibility=hidden )
+    SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter" )
+    IF(NOT WIN32)
+        SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden" )
+    ENDIF()
 ENDIF()
 
 
 IF( UNIX AND NOT APPLE )
     set( Charm_EXECUTABLE charmtimetracker )
-    SET( BIN_INSTALL_DIR bin )
-    SET( DOC_INSTALL_DIR share/doc/${Charm_EXECUTABLE} )
 ELSE()
     set( Charm_EXECUTABLE Charm )
-    SET( BIN_INSTALL_DIR . )
+ENDIF()
+
+SET( BIN_INSTALL_DIR bin )
+SET( DOC_INSTALL_DIR share/doc/${Charm_EXECUTABLE} )
+SET( ICONS_DIR "${CMAKE_SOURCE_DIR}/Charm/Icons" )
+
+IF( CHARM_PREPARE_DEPLOY AND WIN32 OR APPLE)
+SET( BIN_INSTALL_DIR . )
     SET( DOC_INSTALL_DIR . )
 ENDIF()
-SET( ICONS_DIR "${CMAKE_SOURCE_DIR}/Charm/Icons" )
 
 OPTION( CHARM_IDLE_DETECTION "Build the Charm idle detector" ON )
 OPTION( CHARM_TIMESHEET_TOOLS "Build the Charm timesheet tools" OFF )
@@ -221,6 +243,8 @@
     OPTION( CHARM_CI_TCPSERVER "Build Charm with TCP command interface support" ON )
     OPTION( CHARM_CI_LOCALSERVER "Build Charm with local socket command interface support" ON )
 ENDIF()
+
+OPTION(CHARM_PREPARE_DEPLOY "Deploy dependencies with install target(Windows, Apple)" ON)
 
 ADD_SUBDIRECTORY( Core )
 ADD_SUBDIRECTORY( Charm )
