=== Charm/CMakeLists.txt ===
--- 
+++ 
@@ -50,7 +50,6 @@
     Widgets/EventEditor.cpp
     Widgets/EventEditorDelegate.cpp
     Widgets/EventView.cpp
-    Widgets/EventWindow.cpp
     Widgets/ExpandStatesHelper.cpp
     Widgets/HttpJobProgressDialog.cpp
     Widgets/IdleCorrectionDialog.cpp
@@ -64,7 +63,6 @@
     Widgets/TaskEditor.cpp
     Widgets/TasksView.cpp
     Widgets/TasksViewDelegate.cpp
-    Widgets/TasksWindow.cpp
     Widgets/TimeTrackingView.cpp
     Widgets/TimeTrackingWindow.cpp
     Widgets/TimeTrackingTaskSelector.cpp
@@ -73,6 +71,7 @@
     Widgets/WeeklyTimesheet.cpp
     Widgets/NotificationPopup.cpp
     Widgets/FindAndReplaceEventsDialog.cpp
+    Widgets/WidgetUtils.cpp
 )
 
 SET(CharmApplication_LIBS)
@@ -97,42 +96,57 @@
     ELSEIF( WIN32 )
         LIST( APPEND CharmApplication_SRCS Idle/WindowsIdleDetector.cpp )
     ELSEIF( UNIX )
-        FIND_PACKAGE( X11 )
-        IF( X11_FOUND AND X11_Xscreensaver_LIB )
-            MESSAGE( "X11 idle detection enabled." )
-            INCLUDE_DIRECTORIES( ${X11_INCLUDE_DIR} )
-            LIST( APPEND CharmApplication_SRCS Idle/X11IdleDetector.cpp )
-            LIST( APPEND CharmApplication_LIBS ${X11_X11_LIB} ${X11_Xscreensaver_LIB} )
-            SET( CHARM_IDLE_DETECTION_AVAILABLE_X11 "1" CACHE INTERNAL "" )
+        SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/CMake/Modules/ )
+        IF( Qt5Core_FOUND )
+            FIND_PACKAGE( XCB )
+            IF( XCB_INCLUDE_PATH_FOUND AND XCB_LIBRARIES_FOUND AND XCB_SCREENSAVER_LIBRARIES_FOUND  )
+                INCLUDE_DIRECTORIES( ${XCB_INCLUDE_DIRS} )
+                LIST( APPEND CharmApplication_LIBS ${XCB_LIBRARIES} ${XCB_SCREENSAVER_LIBRARIES} )
+                LIST( APPEND CharmApplication_SRCS Idle/X11IdleDetector.cpp )
+                SET( CHARM_IDLE_DETECTION_AVAILABLE "1" CACHE INTERNAL "" )
+            ELSE()
+                SET( CHARM_IDLE_DETECTION_AVAILABLE "0" CACHE INTERNAL "" )
+                MESSAGE( "QT5: Install Xcb headers and library for Xcb idle detection." )
+            ENDIF()
         ELSE()
-            MESSAGE( "Install X11/XScreenSaver headers and library for X11 idle detection." )
+            FIND_PACKAGE( X11 )
+            IF(  X11_FOUND AND X11_Xscreensaver_LIB)
+                INCLUDE_DIRECTORIES( ${X11_INCLUDE_DIR} )
+                LIST( APPEND CharmApplication_LIBS ${X11_X11_LIB} ${X11_Xscreensaver_LIB} )
+                LIST( APPEND CharmApplication_SRCS Idle/X11IdleDetector.cpp )
+                SET( CHARM_IDLE_DETECTION_AVAILABLE "1" CACHE INTERNAL "" )
+            ELSE()
+                SET( CHARM_IDLE_DETECTION_AVAILABLE "0" CACHE INTERNAL "" )
+                MESSAGE( "QT4: Install X11/XScreenSaver headers and library for X11 idle detection." )
+            ENDIF()
         ENDIF()
     ENDIF()
 ENDIF()
 
-LIST( APPEND CharmApplication_SRCS Keychain/keychain.cpp )
-
-IF (APPLE)
-    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp MacApplicationCore.mm )
-
-    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
-    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )
-
-    FIND_LIBRARY( SECURITY_LIBRARY Security )
-    LIST( APPEND CharmApplication_LIBS ${SECURITY_LIBRARY} )
-
-    FIND_LIBRARY( APPKIT_LIBRARY AppKit )
-    LIST( APPEND CharmApplication_LIBS ${APPKIT_LIBRARY} )
-ELSEIF ( WIN32 )
-    LIST( APPEND CharmApplication_SRCS Keychain/keychain_win.cpp )
-ELSEIF ( UNIX )
-    IF (HAVE_DBUS)
-        LIST( APPEND CharmApplication_SRCS Keychain/gnomekeyring.cpp Keychain/keychain_unix.cpp )
-        QT_ADD_DBUS_INTERFACE( CharmApplication_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/Keychain/org.kde.KWallet.xml kwallet_interface KWalletInterface )
-        LIST( APPEND CharmApplication_LIBS ${QT_QTDBUS_LIBRARY} )
-    ELSE()
-        LIST( APPEND CharmApplication_SRCS Keychain/keychain_unsecure.cpp )
-    ENDIF()
+IF (NOT QTKEYCHAIN_SYSTEM)
+	LIST( APPEND CharmApplication_SRCS Keychain/keychain.cpp )
+	IF (APPLE)
+	    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp MacApplicationCore.mm )
+
+	    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
+	    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )
+
+	    FIND_LIBRARY( SECURITY_LIBRARY Security )
+	    LIST( APPEND CharmApplication_LIBS ${SECURITY_LIBRARY} )
+
+	    FIND_LIBRARY( APPKIT_LIBRARY AppKit )
+	    LIST( APPEND CharmApplication_LIBS ${APPKIT_LIBRARY} )
+	ELSEIF ( WIN32 )
+	    LIST( APPEND CharmApplication_SRCS Keychain/keychain_win.cpp )
+	ELSEIF ( UNIX )
+	    IF (HAVE_DBUS)
+		LIST( APPEND CharmApplication_SRCS Keychain/gnomekeyring.cpp Keychain/keychain_unix.cpp )
+		QT_ADD_DBUS_INTERFACE( CharmApplication_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/Keychain/org.kde.KWallet.xml kwallet_interface KWalletInterface )
+		LIST( APPEND CharmApplication_LIBS ${QT_QTDBUS_LIBRARY} )
+	    ELSE()
+		LIST( APPEND CharmApplication_SRCS Keychain/keychain_unsecure.cpp )
+	    ENDIF()
+	ENDIF()
 ENDIF()
 
 QT_WRAP_UI(
@@ -162,7 +176,7 @@
     CharmApplication STATIC
     ${CharmApplication_SRCS} ${UiGenerated_SRCS}
 )
-TARGET_LINK_LIBRARIES(CharmApplication ${CharmApplication_LIBS})
+TARGET_LINK_LIBRARIES(CharmApplication ${CharmApplication_LIBS} ${QT_LIBRARIES})
 
 SET( Charm_SRCS Charm.cpp )
 
@@ -187,7 +201,7 @@
     FILE( COPY ${ICON} DESTINATION ${RESOURCES} )
 ENDIF()
 
-IF( MSVC )
+IF(WIN32)
     SET( Resources_SRCS ${Resources_SRCS} Charm.rc )
 ENDIF()
 
@@ -217,7 +231,7 @@
 )
 
 # Only support CPack packaging on newer versions of CMake.
-IF( NOT "${CMAKE_VERSION}" VERSION_LESS "2.8.4" )
+IF( NOT "${CMAKE_VERSION}" VERSION_LESS "2.8.4" AND CHARM_PREPARE_DEPLOY )
     IF( CMAKE_BUILD_TYPE MATCHES "^([Dd][Ee][Bb][Uu][Gg])" )
         SET( CMAKE_INSTALL_DEBUG_LIBRARIES_ONLY TRUE )
     ENDIF()
@@ -249,5 +263,7 @@
         # Deploy qsqlite plugin
         GET_TARGET_PROPERTY( _loc Qt5::QSQLiteDriverPlugin LOCATION )
         INSTALL( FILES ${_loc} DESTINATION plugins/sqldrivers )
-    ENDIF()
-ENDIF()
+        # Install qt.conf (prevents plugins from the built-in Qt path to be used)
+        INSTALL(FILES qt.conf.in.windows RENAME qt.conf DESTINATION .)
+    ENDIF()
+ENDIF()
