=== debian/changelog ===
charmtimetracker (1.11.1-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * New upstream release
  * Add qtscript5-dev to Build-Deps
  * Bump Standards-Version (no change needed).
  * Update copyright file
  * Patch updates:
    - Remove upstream applied patches (use system qtkeychain)
    - Update patch hunks
    - Add patch to fix the licenses in cmake folder (source: upstream)
  * Activate hardening flags

  [ Maximiliano Curia ]
  * Make sure -fPIC is present in the buildflags (Closes: #828878) Thanks to
    Chris Lamb for the report.

 -- Sandro Knauß <bugs@sandroknauss.de>  Thu, 26 May 2016 11:13:26 +0200
