=== debian/control ===
--- 
+++ 
@@ -8,9 +8,10 @@
                libqt5sql5-sqlite,
                qtbase5-dev,
                qt5keychain-dev,
+               qtscript5-dev,
                xauth,
                xvfb
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/KDAB/Charm
 Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/charmtimetracker.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/charmtimetracker.git
