=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,10 @@
 #!/usr/bin/make -f
-export DH_VERBOSE = 1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+include /usr/share/dpkg/buildflags.mk
 
 include /usr/share/dpkg/default.mk
-export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -DQT_NO_DEBUG_OUTPUT
+export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -DQT_NO_DEBUG_OUTPUT -fPIC
 
 %:
 	dh $@ --parallel
