=== Charm/CMakeLists.txt ===
--- 
+++ 
@@ -76,6 +76,19 @@
 
 SET(CharmApplication_LIBS)
 
+IF (APPLE)
+    LIST(APPEND CharmApplication_SRCS MacApplicationCore.mm)
+
+    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
+    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )
+
+    FIND_LIBRARY( SECURITY_LIBRARY Security )
+    LIST( APPEND CharmApplication_LIBS ${SECURITY_LIBRARY} )
+
+    FIND_LIBRARY( APPKIT_LIBRARY AppKit )
+    LIST( APPEND CharmApplication_LIBS ${APPKIT_LIBRARY} )
+ENDIF()
+
 IF( CHARM_CI_SUPPORT )
     LIST( APPEND CharmApplication_SRCS
         CI/CharmCommandInterface.cpp
@@ -126,7 +139,7 @@
 IF (NOT QTKEYCHAIN_SYSTEM)
 	LIST( APPEND CharmApplication_SRCS Keychain/keychain.cpp )
 	IF (APPLE)
-	    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp MacApplicationCore.mm )
+	    LIST( APPEND CharmApplication_SRCS Keychain/keychain_mac.cpp )
 
 	    FIND_LIBRARY( COREFOUNDATION_LIBRARY CoreFoundation )
 	    LIST( APPEND CharmApplication_LIBS ${COREFOUNDATION_LIBRARY} )
@@ -177,6 +190,9 @@
     ${CharmApplication_SRCS} ${UiGenerated_SRCS}
 )
 TARGET_LINK_LIBRARIES(CharmApplication ${CharmApplication_LIBS} ${QT_LIBRARIES})
+IF(QTKEYCHAIN_SYSTEM)
+    TARGET_INCLUDE_DIRECTORIES(CharmApplication PRIVATE ${QTKEYCHAIN_INCLUDE_DIRS})
+ENDIF()
 
 SET( Charm_SRCS Charm.cpp )
 
@@ -263,6 +279,9 @@
         # Deploy qsqlite plugin
         GET_TARGET_PROPERTY( _loc Qt5::QSQLiteDriverPlugin LOCATION )
         INSTALL( FILES ${_loc} DESTINATION plugins/sqldrivers )
+        # Deploy windowsprintersupport plugin
+        GET_TARGET_PROPERTY( _loc Qt5::QWindowsPrinterSupportPlugin LOCATION )
+        INSTALL( FILES ${_loc} DESTINATION plugins/printsupport )
         # Install qt.conf (prevents plugins from the built-in Qt path to be used)
         INSTALL(FILES qt.conf.in.windows RENAME qt.conf DESTINATION .)
     ENDIF()
