=== debian/changelog ===
charmtimetracker (1.11.4-2) unstable; urgency=medium

  * Fix "Missing binary dependency on libqt5sql5-sqlite" (Closes: #873918)
    - Adding libqt5sql5-sqlite to depends list of charmtimetracker.
  * Bump Standards-Version to 4.1.0 (no change needed).

 -- Sandro Knauß <hefee@debian.org>  Sat, 09 Sep 2017 16:59:35 +0200

charmtimetracker (1.11.4-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * New upstream version.
  * Change my own mailaddress to hefee@debian.org.
  * Add support for Xcb idle detection (Closes: #834885).
  * Use secure URI for VCS field.

 -- Sandro Knauß <hefee@debian.org>  Thu, 10 Nov 2016 09:33:30 +0100
