=== debian/control ===
Source: charmtimetracker
Section: misc
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: cmake,
               debhelper (>= 10),
               libqt5sql5-sqlite,
               libxcb-screensaver0-dev,
               libxcb1-dev,
               qt5keychain-dev,
               qtbase5-dev,
               qtscript5-dev,
               xauth,
               xvfb
Standards-Version: 4.1.0
Homepage: https://github.com/KDAB/Charm
Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-extras/charmtimetracker.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/charmtimetracker.git

Package: charmtimetracker
Architecture: any
Depends: libqt5sql5-sqlite, ${misc:Depends}, ${shlibs:Depends}
Description: Cross-Platform Time Tracker
 It is built around two major ideas - tasks and events.
 Tasks are the things time is spend on, repeatedly. Tasks
 are done in events.
 .
 For example, ironing laundry is a task. The laundry done
 for two hours on last Tuesday is an event in that task.
